123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709710711712713 |
- #!/bin/bash
- #
- # .---. . .
- # | | |
- # |--- .--. .-. .-. .-.| .-. .--.--. |.-. .-. .--. .-.
- # | | (.-' (.-' ( | ( )| | | | )( )| | (.-'
- # ' ' --' --' -' - -' ' ' -' -' -' ' - --'
- #
- # Freedom in the Cloud
- #
- # Tox Application
- #
- # License
- # =======
- #
- # Copyright (C) 2014-2016 Bob Mottram <bob@freedombone.net>
- #
- # This program is free software: you can redistribute it and/or modify
- # it under the terms of the GNU Affero General Public License as published by
- # the Free Software Foundation, either version 3 of the License, or
- # (at your option) any later version.
- #
- # This program is distributed in the hope that it will be useful,
- # but WITHOUT ANY WARRANTY; without even the implied warranty of
- # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
- # GNU Affero General Public License for more details.
- #
- # You should have received a copy of the GNU Affero General Public License
- # along with this program. If not, see <http://www.gnu.org/licenses/>.
-
- VARIANTS='full full-vim chat'
-
- IN_DEFAULT_INSTALL=0
- SHOW_ON_ABOUT=1
-
- TOX_PORT=33445
- TOXCORE_REPO="https://github.com/bashrc/toxcore"
- TOXCORE_COMMIT='d3fa9f82bda3a8746917502c525237427ba17d45'
- TOXID_REPO="https://github.com/bashrc/toxid"
- TOX_BOOTSTRAP_ID_FILE=/var/lib/tox-bootstrapd/pubkey.txt
- # These are some default nodes, but you can replace them with trusted nodes
- # as you prefer. See https://wiki.tox.im/Nodes
- TOX_NODES=
- #TOX_NODES=(
- # '192.254.75.102,2607:5600:284::2,33445,951C88B7E75C867418ACDB5D273821372BB5BD652740BCDF623A4FA293E75D2F,Tox RELENG,US'
- # '144.76.60.215,2a01:4f8:191:64d6::1,33445,04119E835DF3E78BACF0F84235B300546AF8B936F035185E2A8E9E0A67C8924F,sonOfRa,DE'
- #)
- TOXIC_REPO="https://github.com/Tox/toxic"
- TOXIC_COMMIT='cf16849b374e484a33a4dffa3dfb937b59d537f2'
- TOXIC_FILE=/usr/local/bin/toxic
-
- QTOX_REPO="https://github.com/bashrc/qTox"
- QTOX_COMMIT='27a628a3789fca4f31516c3982e580052dd3c773'
-
- tox_variables=(SYSTEM_TYPE
- TOXCORE_REPO
- TOXCORE_COMMIT
- TOXIC_COMMIT
- MY_USERNAME
- ONION_ONLY
- INSTALLED_WITHIN_DOCKER
- TOX_PORT
- TOX_NODES)
-
- function remove_user_tox {
- remove_username="$1"
-
- if [ -d /home/$remove_username/.config/tox ]; then
- if [ -d /home/$remove_username/.config/tox/chatlogs ]; then
- shred -zu /home/$remove_username/.config/tox/chatlogs/*
- rm -rf /home/$remove_username/.config/tox/chatlogs
- fi
- shred -zu /home/$remove_username/.config/tox/*
- fi
- }
-
- function add_user_tox {
- new_username="$1"
-
- # Note: password isn't used
- new_user_password="$2"
-
- USER_TOX_FILE=/home/${new_username}/.config/tox/data.tox
- if [ ! -f $USER_TOX_FILE ]; then
- mkdir -p /home/${new_username}/.config/tox
- chown -R ${new_username}:${new_username} /home/${new_username}/.config
- su -c "toxid -u ${new_username} -n data" - $new_username
- su -c "toxid --setuser ${new_username}" - $new_username
- fi
- }
-
- function run_client_tox {
- # create a tox user
- USER_TOX_FILE=/home/${USER}/.config/tox/data.tox
- if [ ! -f $USER_TOX_FILE ]; then
- mkdir -p /home/${USER}/.config/tox
- chown -R ${USER}:${USER} /home/${USER}/.config
- toxid -u ${USER} -n data
- toxid --setuser ${USER}
- fi
- toxic -f $USER_TOX_FILE --force-tcp --SOCKS5-proxy 127.0.0.1 9050
- }
-
- function install_interactive_tox {
- echo -n ''
- APP_INSTALLED=1
- }
-
- function change_password_tox {
- echo -n ''
- }
-
- function mesh_tox_qtox {
- if [ ! ${rootdir}$INSTALL_DIR ]; then
- INSTALL_DIR=${rootdir}/root/build
- fi
-
- if [ ! -d ${rootdir}$INSTALL_DIR ]; then
- mkdir -p ${rootdir}$INSTALL_DIR
- fi
-
- chroot "${rootdir}" apt-get -yq install build-essential libatk1.0-0 libbz2-1.0 libc6 libcairo2 libdbus-1-3 libegl1-mesa libfontconfig1 libfreetype6 libgcc1 libgdk-pixbuf2.0-0 libgl1-mesa-glx libglib2.0-0 libgtk2.0-0 libice6 libicu52 libjpeg62-turbo libmng1 libmtdev1 libopenal1 libopus0 libpango-1.0-0 libpangocairo-1.0-0 libpangoft2-1.0-0 libpng12-0 libqrencode3 libsm6 libsodium13 libsqlite3-0 libssl1.0.0 libstdc++6 libtiff5 libudev1 libvpx1 libwayland-client0 libwayland-cursor0 libwayland-egl1-mesa libwebp5 libx11-6 libx11-xcb1 libxcb-glx0 libxcb-icccm4 libxcb-image0 libxcb-keysyms1 libxcb-randr0 libxcb-render-util0 libxcb-render0 libxcb-shape0 libxcb-shm0 libxcb-sync1 libxcb-xfixes0 libxcb-xinerama0 libxcb1 libxext6 libxfixes3 libxi6 libxrender1 libxss1 zlib1g libopus-dev libvpx-dev
- chroot "${rootdir}" apt-get -yq install build-essential qt5-qmake qt5-default qttools5-dev-tools libqt5opengl5-dev libqt5svg5-dev libopenal-dev libxss-dev qrencode libqrencode-dev libglib2.0-dev libgdk-pixbuf2.0-dev libgtk2.0-dev libsqlcipher-dev libopus-dev libvpx-dev libavformat-dev libavdevice-dev libswscale-dev libavutil-dev libavcodec-dev libavcodec56 libavcodec57 libavfilter-dev libavfilter6
-
- mesh_install_ffmpeg
-
- git clone $QTOX_REPO ${rootdir}$INSTALL_DIR/qtox
- if [ ! -d ${rootdir}$INSTALL_DIR/qtox ]; then
- exit 72428
- fi
- cd ${rootdir}${INSTALL_DIR}/qtox
- git checkout $QTOX_COMMIT -b $QTOX_COMMIT
- chroot ${rootdir} /bin/bash -x <<EOF
- cd ${INSTALL_DIR}/qtox
- qmake
- make
- make install
- EOF
- if [ ! -f ${rootdir}/usr/bin/qtox ]; then
- exit 75784
- fi
- }
-
- function reconfigure_tox {
- echo -n ''
- }
-
- function upgrade_tox {
- function_check set_repo_commit
- set_repo_commit $INSTALL_DIR/toxcore "toxcore commit" "$TOXCORE_COMMIT" $TOXCORE_REPO
- if [[ $(commit_has_changed $INSTALL_DIR/toxcore "toxcore commit" "$TOXCORE_COMMIT") == "1" ]]; then
- cd $INSTALL_DIR/toxcore
- sed -i 's|ExecStart=.*|ExecStart=/usr/local/bin/tox-bootstrapd --config /etc/tox-bootstrapd.conf|g' $rootdir/etc/systemd/system/tox-bootstrapd.service
- autoreconf -i
- ./configure --enable-daemon
- make
- make install
- systemctl daemon-reload
- systemctl restart tox-bootstrapd.service
- fi
-
- function_check set_repo_commit
- set_repo_commit $INSTALL_DIR/toxic "Toxic commit" "$TOXIC_COMMIT" $TOXIC_REPO
- if [[ $(commit_has_changed $INSTALL_DIR/toxic "Toxic commit" "$TOXIC_COMMIT") == "1" ]]; then
- cd $INSTALL_DIR/toxic
- make
- make install
- fi
- }
-
- function backup_local_tox {
- if [ -d /var/lib/tox-bootstrapd ]; then
- echo $"Backing up Tox"
-
- if [ -d /var/lib/tox-bootstrapd ]; then
- cp /etc/tox-bootstrapd.conf /var/lib/tox-bootstrapd
- if [ -d /var/lib/tox-bootstrapd/Maildir ]; then
- rm -rf /var/lib/tox-bootstrapd/Maildir
- fi
- fi
-
- function_check backup_directory_to_usb
- backup_directory_to_usb /var/lib/tox-bootstrapd tox
-
- echo $"Backup of Tox complete"
- fi
- }
-
- function restore_local_tox {
- if [ -d $USB_MOUNT/backup/tox ]; then
- echo $"Restoring Tox node settings"
- function_check restore_directory_from_usb
- restore_directory_from_usb / tox
- if [ ! "$?" = "0" ]; then
- function_check set_user_permissions
- set_user_permissions
- function_check backup_unmount_drive
- backup_unmount_drive
- exit 6393
- fi
- cp /var/lib/tox-bootstrapd/tox-bootstrapd.conf /etc/tox-bootstrapd.conf
- systemctl restart tox-bootstrapd.service
- if [ ! "$?" = "0" ]; then
- systemctl status tox-bootstrapd.service
- function_check set_user_permissions
- set_user_permissions
- function_check backup_unmount_drive
- backup_unmount_drive
- exit 59369
- fi
- fi
- }
-
- function backup_remote_tox {
- if [ -d /var/lib/tox-bootstrapd ]; then
- echo "Backing up Tox node settings"
- if [ -d /var/lib/tox-bootstrapd/Maildir ]; then
- rm -rf /var/lib/tox-bootstrapd/Maildir
- fi
- cp /etc/tox-bootstrapd.conf /var/lib/tox-bootstrapd
- backup_directory_to_friend /var/lib/tox-bootstrapd tox
- echo "Backup of Tox node settings complete"
- fi
- }
-
- function restore_remote_tox {
- if [ -d $SERVER_DIRECTORY/backup/tox ]; then
- echo $"Restoring Tox node settings"
- function_check restore_directory_from_friend
- restore_directory_from_friend / tox
- if [ ! "$?" = "0" ]; then
- exit 93653
- fi
- cp /var/lib/tox-bootstrapd/tox-bootstrapd.conf /etc/tox-bootstrapd.conf
- systemctl restart tox-bootstrapd.service
- if [ ! "$?" = "0" ]; then
- systemctl status tox-bootstrapd.service
- exit 59369
- fi
- echo $"Restore of Tox node complete"
- fi
- }
-
- function remove_tox_node {
- firewall_remove ${TOX_PORT}
-
- function_check remove_onion_service
- remove_onion_service tox ${TOX_PORT}
-
- ${PROJECT_NAME}-mesh-install -f tox_node --remove yes
- if [ ! "$?" = "0" ]; then
- echo $'Failed to remove tox node'
- exit 763836
- fi
- remove_completion_param install_tox_node
- remove_completion_param configure_firewall_for_tox
- sed -i '/Tox' /home/$MY_USERNAME/README
- sed -i '/tox ' /home/$MY_USERNAME/README
- }
-
- function remove_tox_avahi {
- cd $INSTALL_DIR/toxid
- make uninstall
- rm -rf $INSTALL_DIR/toxid
- sed -i '/tox_avahi/d' $COMPLETION_FILE
- }
-
- function remove_tox_client {
- ${PROJECT_NAME}-mesh-install -f tox_client --remove yes
- if [ ! "$?" = "0" ]; then
- echo $'Could not remove Tox client'
- exit 737253
- fi
- sed -i '/install_tox_client/d' $COMPLETION_FILE
- sed -i '/Tox /d' $COMPLETION_FILE
- sed -i '/Toxic /d' $COMPLETION_FILE
- }
-
- function remove_tox {
- remove_tox_client
- remove_tox_avahi
- remove_tox_node
- }
-
- function configure_firewall_for_tox {
- if [ ! $INSTALLING_MESH ]; then
- if [[ $(is_completed $FUNCNAME) == "1" ]]; then
- return
- fi
- fi
-
- if [[ $INSTALLED_WITHIN_DOCKER == "yes" ]]; then
- # docker does its own firewalling
- return
- fi
- if [[ $ONION_ONLY != "no" ]]; then
- return
- fi
-
- TOX_PORT_MAIN=$(cat /usr/share/${PROJECT_NAME}/apps/${PROJECT_NAME}-app-tox | grep "TOX_PORT=" | head -n 1 | awk -F '=' '{print $2}')
- if [ ${#TOX_PORT_MAIN} -gt 2 ]; then
- TOX_PORT=$TOX_PORT_MAIN
- fi
- if [ ! $TOX_PORT ]; then
- echo $'No Tox port was specified'
- exit 32856
- fi
-
- firewall_add Tox ${TOX_PORT}
- mark_completed $FUNCNAME
- }
-
- function tox_avahi {
- if [[ $(is_completed $FUNCNAME) == "1" ]]; then
- return
- fi
-
- if [ ! -d /etc/avahi ]; then
- echo $'tox_avahi: avahi is not installed'
- exit 87359
- fi
-
- # install a command to obtain the Tox ID
- cd $INSTALL_DIR
- function_check git_clone
- git_clone $TOXID_REPO $INSTALL_DIR/toxid
- if [ ! -d $INSTALL_DIR/toxid ]; then
- exit 63921
- fi
- cd $INSTALL_DIR/toxid
- make
- if [ ! "$?" = "0" ]; then
- exit 58432
- fi
- make install
-
- if [[ $SYSTEM_TYPE == "mesh"* ]]; then
- toxavahi
-
- # publish regularly
- function_check cron_add_mins
- cron_add_mins 1 'toxavahi 2> /dev/null'
- fi
-
- systemctl restart avahi-daemon
-
- mark_completed $FUNCNAME
- }
-
- function install_tox_node {
- if [[ $(app_is_installed tox_node) == "1" ]]; then
- return
- fi
-
- function_check mesh_tox_node
- mesh_tox_node
-
- # onion address for bootstrapping
- TOX_ONION_HOSTNAME=$(add_onion_service tox ${TOX_PORT} ${TOX_PORT})
-
- systemctl restart tox-bootstrapd.service
-
- sleep 3
-
- TOX_PUBLIC_KEY=$(cat /var/log/syslog | grep tox | grep "Public Key" | tail -n 1 | awk -F ' ' '{print $8}')
- if [ ${#TOX_PUBLIC_KEY} -lt 30 ]; then
- echo $'Could not obtain the tox node public key'
- exit 6529
- fi
-
- # save the public key for later reference
- echo "$TOX_PUBLIC_KEY" > $TOX_BOOTSTRAP_ID_FILE
-
- function_check configure_firewall_for_tox
- configure_firewall_for_tox
-
- if ! grep -q $"Your Tox node public key is" /home/$MY_USERNAME/README; then
- echo '' >> /home/$MY_USERNAME/README
- echo '' >> /home/$MY_USERNAME/README
- echo '# Tox' >> /home/$MY_USERNAME/README
- echo $"tox onion domain: ${TOX_ONION_HOSTNAME}" >> /home/$MY_USERNAME/README
- echo $"Your Tox node public key is: $TOX_PUBLIC_KEY" >> /home/$MY_USERNAME/README
- chown $MY_USERNAME:$MY_USERNAME /home/$MY_USERNAME/README
- chmod 600 /home/$MY_USERNAME/README
- fi
-
- function_check configure_firewall_for_tox
- configure_firewall_for_tox
- install_completed tox_node
- }
-
- function install_tox_client {
- if [[ $(app_is_installed tox_client) == "1" ]]; then
- return
- fi
-
- function_check mesh_tox_client
- mesh_tox_client
-
- install_completed tox_client
- }
-
- function mesh_tox_node {
- # obtain commits from the main file
- TOXCORE_COMMIT_MAIN=$(cat /usr/share/${PROJECT_NAME}/apps/${PROJECT_NAME}-app-tox | grep "TOXCORE_COMMIT=" | head -n 1 | awk -F "'" '{print $2}')
- if [ ${#TOXCORE_COMMIT_MAIN} -gt 10 ]; then
- TOXCORE_COMMIT=$TOXCORE_COMMIT_MAIN
- fi
- if [ ! $TOXCORE_COMMIT ]; then
- echo $'No Tox commit was specified'
- exit 76325
- fi
-
- TOXID_REPO_MAIN=$(cat /usr/share/${PROJECT_NAME}/apps/${PROJECT_NAME}-app-tox | grep "TOXID_REPO=" | head -n 1 | awk -F '"' '{print $2}')
- if [ ${#TOXID_REPO_MAIN} -gt 5 ]; then
- TOXID_REPO=$TOXID_REPO_MAIN
- fi
- if [ ! $TOXID_REPO ]; then
- echo $'No ToxID repo was specified'
- exit 78252
- fi
-
- TOX_PORT_MAIN=$(cat /usr/share/${PROJECT_NAME}/apps/${PROJECT_NAME}-app-tox | grep "TOX_PORT=" | head -n 1 | awk -F '=' '{print $2}')
- if [ ${#TOX_PORT_MAIN} -gt 2 ]; then
- TOX_PORT=$TOX_PORT_MAIN
- fi
- if [ ! $TOX_PORT ]; then
- echo $'No Tox port was specified'
- exit 32856
- fi
-
- TOXCORE_REPO_MAIN=$(cat /usr/share/${PROJECT_NAME}/apps/${PROJECT_NAME}-app-tox | grep "TOXCORE_REPO=" | head -n 1 | awk -F '"' '{print $2}')
- if [ ${#TOXCORE_REPO_MAIN} -gt 10 ]; then
- TOXCORE_REPO=$TOXCORE_REPO_MAIN
- fi
- if [ ! $TOXCORE_REPO ]; then
- echo $'No Tox repo was specified'
- exit 16865
- fi
-
- if [ ! $TOXCORE_COMMIT ]; then
- echo $'No Tox commit was specified'
- exit 76325
- fi
-
- if [ ! $TOXCORE_REPO ]; then
- echo $'No Tox repo was specified'
- exit 16865
- fi
-
- if [ $rootdir ]; then
- chroot ${rootdir} apt-get -yq install build-essential libtool autotools-dev
- chroot ${rootdir} apt-get -yq install automake checkinstall check git yasm
- chroot ${rootdir} apt-get -yq install libsodium13 libsodium-dev libcap2-bin
- chroot ${rootdir} apt-get -yq install libconfig9 libconfig-dev autoconf
- chroot ${rootdir} apt-get -yq install libopus-dev libvpx-dev
- else
- apt-get -yq install build-essential libtool autotools-dev
- apt-get -yq install automake checkinstall check git yasm
- apt-get -yq install libsodium13 libsodium-dev libcap2-bin
- apt-get -yq install libconfig9 libconfig-dev autoconf
- apt-get -yq install libopus-dev libvpx-dev
- fi
-
- if [ ! -d ${rootdir}${INSTALL_DIR} ]; then
- mkdir -p ${rootdir}${INSTALL_DIR}
- fi
- if [ ! -d ${rootdir}${INSTALL_DIR}/toxcore ]; then
- git clone ${TOXCORE_REPO} ${rootdir}${INSTALL_DIR}/toxcore
- if [ ! "$?" = "0" ]; then
- exit 429252
- fi
- fi
- cd ${rootdir}$INSTALL_DIR/toxcore
- git checkout $TOXCORE_COMMIT -b $TOXCORE_COMMIT
-
- if [ ${rootdir} ]; then
- chroot ${rootdir} /bin/bash -x <<EOF
- cd ${INSTALL_DIR}/toxcore
- autoreconf -i
- ./configure --enable-daemon
- make
- make install
- EOF
- else
- /bin/bash -x <<EOF
- cd ${INSTALL_DIR}/toxcore
- autoreconf -i
- ./configure --enable-daemon
- make
- make install
- EOF
- fi
-
- cp $rootdir/usr/local/lib/libtoxcore* $rootdir/usr/lib/
- cp ${rootdir}${INSTALL_DIR}/toxcore/other/bootstrap_daemon/tox-bootstrapd.service $rootdir/etc/systemd/system/
- sed -i 's|ExecStart=.*|ExecStart=/usr/local/bin/tox-bootstrapd --config /etc/tox-bootstrapd.conf|g' $rootdir/etc/systemd/system/tox-bootstrapd.service
- if [ ${rootdir} ]; then
- chroot ${rootdir} systemctl enable tox-bootstrapd.service
- else
- systemctl enable tox-bootstrapd.service
- fi
-
- SECONDS=0
- if [ ! -f $rootdir/usr/local/bin/tox-bootstrapd ]; then
- duration=$SECONDS
- echo $"Toxcore compile failed at $(($duration / 60)) minutes and $(($duration % 60)) seconds elapsed."
- echo $'Unable to make toxcore'
- exit 73835
- fi
- duration=$SECONDS
- echo $"Toxcore compile $(($duration / 60)) minutes and $(($duration % 60)) seconds elapsed."
-
- if [ ${rootdir} ]; then
- chroot ${rootdir} /usr/sbin/useradd --home-dir /var/lib/tox-bootstrapd --create-home --system --shell /sbin/nologin --comment $"Account to run Tox's DHT bootstrap daemon" --user-group tox-bootstrapd
- chroot ${rootdir} /bin/chmod 700 /var/lib/tox-bootstrapd
- else
- useradd --home-dir /var/lib/tox-bootstrapd --create-home --system --shell /sbin/nologin --comment $"Account to run Tox's DHT bootstrap daemon" --user-group tox-bootstrapd
- chmod 700 /var/lib/tox-bootstrapd
- fi
-
- # remove Maildir
- if [ -d $rootdir/var/lib/tox-bootstrapd/Maildir ]; then
- rm -rf $rootdir/var/lib/tox-bootstrapd/Maildir
- fi
-
- # create configuration file
- TOX_BOOTSTRAP_CONFIG=$rootdir/etc/tox-bootstrapd.conf
- echo "port = $TOX_PORT" > $TOX_BOOTSTRAP_CONFIG
- echo 'keys_file_path = "/var/lib/tox-bootstrapd/keys"' >> $TOX_BOOTSTRAP_CONFIG
- echo 'pid_file_path = "/var/run/tox-bootstrapd/tox-bootstrapd.pid"' >> $TOX_BOOTSTRAP_CONFIG
- echo 'enable_ipv6 = true' >> $TOX_BOOTSTRAP_CONFIG
- echo 'enable_ipv4_fallback = true' >> $TOX_BOOTSTRAP_CONFIG
- echo 'enable_lan_discovery = true' >> $TOX_BOOTSTRAP_CONFIG
- echo 'enable_tcp_relay = true' >> $TOX_BOOTSTRAP_CONFIG
- echo "tcp_relay_ports = [443, 3389, $TOX_PORT]" >> $TOX_BOOTSTRAP_CONFIG
- echo 'enable_motd = true' >> $TOX_BOOTSTRAP_CONFIG
- echo 'motd = "tox-bootstrapd"' >> $TOX_BOOTSTRAP_CONFIG
-
- if [ $TOX_NODES ]; then
- echo 'bootstrap_nodes = (' >> $TOX_BOOTSTRAP_CONFIG
- toxcount=0
- while [ "x${TOX_NODES[toxcount]}" != "x" ]
- do
- toxval_ipv4=$(echo $TOX_NODES[toxcount] | awk -F ',' '{print $1}')
- toxval_ipv6=$(echo $TOX_NODES[toxcount] | awk -F ',' '{print $2}')
- toxval_port=$(echo $TOX_NODES[toxcount] | awk -F ',' '{print $3}')
- toxval_pubkey=$(echo $TOX_NODES[toxcount] | awk -F ',' '{print $4}')
- toxval_maintainer=$(echo $TOX_NODES[toxcount] | awk -F ',' '{print $5}')
- echo "{ // $toxval_maintainer" >> $TOX_BOOTSTRAP_CONFIG
- if [[ $toxval_ipv6 != 'NONE' ]]; then
- echo " address = \"$toxval_ipv6\"" >> $TOX_BOOTSTRAP_CONFIG
- else
- echo " address = \"$toxval_ipv4\"" >> $TOX_BOOTSTRAP_CONFIG
- fi
- echo " port = $toxval_port" >> $TOX_BOOTSTRAP_CONFIG
- echo " public_key = \"$toxval_pubkey\"" >> $TOX_BOOTSTRAP_CONFIG
- toxcount=$(( $toxcount + 1 ))
- if [ "x${TOX_NODES[toxcount]}" != "x" ]; then
- echo "}," >> $TOX_BOOTSTRAP_CONFIG
- else
- echo "}" >> $TOX_BOOTSTRAP_CONFIG
- fi
- done
- echo ')' >> $TOX_BOOTSTRAP_CONFIG
- fi
- }
-
- function mesh_tox_avahi {
- if [ ! -d $rootdir/etc/avahi ]; then
- echo $'tox_avahi: avahi is not installed'
- exit 87359
- fi
-
- if [ ! $TOXID_REPO ]; then
- echo $'No ToxID repo was specified'
- exit 78252
- fi
-
- if [ ! -d ${rootdir}${INSTALL_DIR} ]; then
- mkdir -p ${rootdir}${INSTALL_DIR}
- fi
-
- git clone ${TOXID_REPO} ${rootdir}${INSTALL_DIR}/toxid
- if [ ! -d ${rootdir}${INSTALL_DIR}/toxid ]; then
- echo $'Unable to clone toxid repo'
- exit 768352
- fi
-
- if [ ${rootdir} ]; then
- chroot ${rootdir} /bin/bash -x <<EOF
- cd ${INSTALL_DIR}/toxid
- make
- make install
- EOF
- else
- /bin/bash -x <<EOF
- cd ${INSTALL_DIR}/toxid
- make
- make install
- EOF
- fi
-
- if [ ! -f $rootdir/usr/local/bin/toxid ]; then
- echo $'toxid not found'
- exit 74370
- fi
- if [ ! -f $rootdir/usr/local/bin/toxavahi ]; then
- exit 3621729
- fi
-
- MESH_SYNC_COMMAND=$rootdir/usr/bin/mesh-sync
- echo '#!/bin/bash' > $MESH_SYNC_COMMAND
- echo '/usr/local/bin/toxavahi 2> /dev/null' >> $MESH_SYNC_COMMAND
- echo '/usr/local/bin/meshavahi 2> /dev/null' >> $MESH_SYNC_COMMAND
- chmod +x $MESH_SYNC_COMMAND
-
- if ! grep -q "mesh-sync" ${rootdir}/etc/crontab; then
- echo "*/1 * * * * root /usr/bin/mesh-sync 2> /dev/null" >> ${rootdir}/etc/crontab
- echo "*/1 * * * * root ( sleep 20 ; /usr/bin/mesh-sync 2> /dev/null )" >> ${rootdir}/etc/cro echo "*/1 * * * * root ( sleep 40 ; /usr/bin/mesh-sync 2> /dev/null )" >> ${rootdir}/etc/crontab
- fi
- }
-
- function mesh_tox_client {
-
- TOXIC_FILE=$(cat /usr/share/${PROJECT_NAME}/apps/${PROJECT_NAME}-app-tox | grep "TOXIC_FILE=" | head -n 1 | awk -F '=' '{print $2}')
-
- # obtain commits from the main file
- TOXIC_COMMIT_MAIN=$(cat /usr/share/${PROJECT_NAME}/apps/${PROJECT_NAME}-app-tox | grep "TOXIC_COMMIT=" | head -n 1 | awk -F "'" '{print $2}')
- if [ ${#TOXIC_COMMIT_MAIN} -gt 10 ]; then
- TOXIC_COMMIT=$TOXIC_COMMIT_MAIN
- fi
-
- TOXIC_REPO_MAIN=$(cat /usr/share/${PROJECT_NAME}/apps/${PROJECT_NAME}-app-tox | grep "TOXIC_REPO=" | head -n 1 | awk -F '"' '{print $2}')
- if [ ${#TOXIC_REPO_MAIN} -gt 5 ]; then
- TOXIC_REPO=$TOXIC_REPO_MAIN
- fi
-
- if [ ${rootdir} ]; then
- chroot ${rootdir} apt-get -yq install libncursesw5-dev libconfig-dev libqrencode-dev
- chroot ${rootdir} apt-get -yq install libcurl4-openssl-dev libvpx-dev libopenal-dev
- else
- apt-get -yq install libncursesw5-dev libconfig-dev libqrencode-dev
- apt-get -yq install libcurl4-openssl-dev libvpx-dev libopenal-dev
- fi
-
- TEMP_SCRIPT_NAME=fbtmp728353.sh
- TEMP_SCRIPT=/tmp/$TEMP_SCRIPT_NAME
- echo '#!/bin/bash' > $TEMP_SCRIPT
- echo "mkdir -p $INSTALL_DIR" >> $TEMP_SCRIPT
- echo "git clone $TOXIC_REPO $INSTALL_DIR/toxic" >> $TEMP_SCRIPT
- echo "cd $INSTALL_DIR/toxic" >> $TEMP_SCRIPT
- echo "git checkout $TOXIC_COMMIT -b $TOXIC_COMMIT" >> $TEMP_SCRIPT
- echo 'make' >> $TEMP_SCRIPT
- echo 'if [ ! "$?" = "0" ]; then' >> $TEMP_SCRIPT
- echo ' exit 1' >> $TEMP_SCRIPT
- echo 'fi' >> $TEMP_SCRIPT
- echo 'make install' >> $TEMP_SCRIPT
- echo 'exit 0' >> $TEMP_SCRIPT
- chmod +x $TEMP_SCRIPT
- cp $TEMP_SCRIPT $rootdir/root/
-
- TOXIC_FILE=$(cat /usr/share/${PROJECT_NAME}/apps/${PROJECT_NAME}-app-tox | grep "TOXIC_FILE=" | head -n 1 | awk -F '=' '{print $2}')
-
- SECONDS=0
- if [ ${rootdir} ]; then
- chroot ${rootdir} /root/$TEMP_SCRIPT_NAME
- else
- /root/$TEMP_SCRIPT_NAME
- fi
- if [ ! "$?" = "0" ]; then
- duration=$SECONDS
- echo $"Toxic client compile failed at $(($duration / 60)) minutes and $(($duration % 60)) seconds elapsed."
- echo $'Unable to make tox client'
- rm $TEMP_SCRIPT
- exit 74872
- fi
- rm $TEMP_SCRIPT
- if [ ! -f $rootdir$TOXIC_FILE ]; then
- echo $"Tox client was not installed to $TOXIC_FILE"
- exit 63278
- fi
- duration=$SECONDS
- echo $"Toxic client compile $(($duration / 60)) minutes and $(($duration % 60)) seconds elapsed."
- }
-
- function enable_tox_repo {
- echo 'deb http://download.opensuse.org/repositories/home:/antonbatenev:/tox/Debian_8.0/ /' > $rootdir/etc/apt/sources.list.d/tox.list
-
-
- chroot "$rootdir" /usr/bin/wget -q http://download.opensuse.org/repositories/home:antonbatenev:tox/Debian_8.0/Release.key -O- > /root/tox.key
- chroot "$rootdir" apt-key add /root/tox.key
- chroot "$rootdir" rm /root/tox.key
- chroot "$rootdir" apt-get update
- echo "Tox Repository Installed."
- }
-
- function install_tox {
- configure_firewall_for_tox
-
- if [ $INSTALLING_MESH ]; then
- mesh_tox_node
- mesh_tox_avahi
- mesh_tox_client
- else
- install_tox_node
- tox_avahi
- install_tox_client
- fi
- APP_INSTALLED=1
- }
-
- # NOTE: deliberately no exit 0
|